#include "indices.h"
#include <iostream>
#include <QTimer>
#include <QDebug>

getquote::getquote(const QString & code_pays, const QString & host, const QString & url, const QString & reg, QObject *parent)
{
	finished_ = false;
	HttpSock_.setHost(host);
	connect(&HttpSock_, SIGNAL(requestFinished(int, bool)), this, SLOT(httpRequestFinished(int, bool)));
	connect(this, SIGNAL(finito(const QString&)), parent, SLOT(result(const QString&)));
	Reply_to_check_ptz_.open(QBuffer::ReadWrite);

	HttpSock_.get(url, &Reply_to_check_ptz_);
	res_ = code_pays + "=";
	reg_ = reg;
}


getquote_bourso::getquote_bourso(QObject *parent)
{
	const QString URL_p("/indices/indices_intern.phtml");
	HttpSock_.setHost("www.boursorama.com");
	connect(&HttpSock_, SIGNAL(requestFinished(int, bool)), this, SLOT(httpRequestFinished(int, bool)));
	connect(this, SIGNAL(finito(const QString&)), parent, SLOT(result(const QString&)));
	Reply_to_check_ptz_.open(QBuffer::ReadWrite);
	HttpSock_.get(URL_p, &Reply_to_check_ptz_);
}

getquote_index_record::getquote_index_record(QObject *parent)
{
	const QString URL_p("/");
	HttpSock_.setHost("www.indexrecord.com");
	connect(&HttpSock_, SIGNAL(requestFinished(int, bool)), this, SLOT(httpRequestFinished(int, bool)));
	connect(this, SIGNAL(finito(const QString&)), parent, SLOT(result(const QString&)));
	Reply_to_check_ptz_.open(QBuffer::ReadWrite);
	HttpSock_.get(URL_p, &Reply_to_check_ptz_);
}

waiter::waiter(QObject *parent)
	:QObject(parent),
	res_(""),
	counter_(1),
	timeout_(10000) // 10 secondes
{
	connect(this, SIGNAL(allfinito()), parent, SLOT(quit()));
}

inline void waiter::wait_for_one_more_request()
{
	counter_++;
}

void waiter::wait_for_end()
{
	QTimer::singleShot(timeout_, this, SLOT(on_timeout()));

	counter_--;
	if (counter_ == 0)
	{
		output();
	}
}

void waiter::on_timeout()
{
	output();
}

void waiter::result(const QString &res)
{

	res_ += res;
	counter_--;
	if (counter_ == 0)
	{
		output();
	}
}

void waiter::output()
{
 std::cout <<  res_.toAscii().constData();
 emit allfinito();
}

int getquote_bourso::add_country(const QString &country_code, const QString &reg)
{
	QString answer(Reply_to_check_ptz_.data().data());
	QRegExp rx;
	rx.setMinimal(true);
	rx.setPattern(reg);

	int pos = rx.indexIn(answer);
	if (pos > -1) {
		res_ += country_code + "=" + rx.cap(1) + "\n";
		return 0;
	}
	return -1;
}

int getquote_index_record::add_country(const QString &country_code, const QString &country)
{
	QString answer(Reply_to_check_ptz_.data().data());
	QRegExp rx;
	rx.setMinimal(true);
	rx.setPattern(country + ".*>([^<>]*)%");

	int pos = rx.indexIn(answer);
	if (pos > -1) {
		res_ += country_code + "=" + rx.cap(1) + "\n";
		return 0;
	}
	return -1;
}

void getquote_bourso::httpRequestFinished(int id, bool err)
{
	if (err)
	{
		qWarning() << "getquote_bourso::httpRequestFinished, id = " << id << " err = " << err;
		return;
	}
	if (add_country("fr", "CAC *40.*<span[^>]*>([^<]*)%<") < 0)
		return;
	add_country("us", "DOW *JONES.*<span[^>]*>([^<]*)%<");
	add_country("de", "DAX *Xetra.*<span[^>]*>([^<]*)%<");
	add_country("it", "MIB 30.*<span[^>]*>([^<]*)%<");
	add_country("nl", "AEX *25.*<span[^>]*>([^<]*)%<");
	add_country("jp", "Nikkei *225.*<span[^>]*>([^<]*)%<");
	add_country("gb", "FTSE *100.*<span[^>]*>([^<]*)%<");
	add_country("es", "Ibex35.*<span[^>]*>([^<]*)%<");
	add_country("ch", "SMI.*<span[^>]*>([^<]*)%<");
	add_country("be", "BEL *20.*<span[^>]*>([^<]*)%<");
	add_country("cn", "HONG KONG HANG SENG INDIC.*<span[^>]*>([^<]*)%<");
	add_country("ca", "P/TSX.*<span[^>]*>([^<]*)%<");

	emit finito(res_);
}

void getquote_index_record::httpRequestFinished(int id, bool err)
{
	if (err)
	{
		qWarning() << "getquote_index_record::httpRequestFinished, id = " << id << " err = " << err;
		return;
	}
	if (add_country("us", "United States") < 0)
		return;
	add_country("ca","Canada");
	add_country("mx","Mexico");
	add_country("ar","Argentina");
	add_country("br","Brazil");
	add_country("cl","Chile");
	add_country("ve","Venezuela");
	add_country("pe","Peru");
	add_country("co","Colombia");
	add_country("cr","Costa Rica");

	add_country("Ke","Kenya");
	add_country("jp","Japan");
	add_country("cn","China");
	add_country("tw","Taiwan");
	add_country("au","Australia");
	add_country("nz","New Zealand");
	add_country("th","Thailand");
	add_country("id","Indonesia");
	add_country("in","India");
		
	add_country("ba","Bosnia and Herzegovina");
	add_country("mn","Mongolia");

	add_country("bm","Bermuda");
	add_country("jm","Jamaica");
	add_country("uk","United Kingdom");
	add_country("fr","France");
	add_country("ie","Ireland");
	add_country("nl","Netherlands");
	add_country("be","Belgium");
	add_country("lu","Luxembourg");
	add_country("fi","Finland");
	add_country("is","Iceland");

	add_country("bg","Bulgaria");
	add_country("mt","Malta");
	add_country("de","Germany");
	add_country("ch","Switzerland");
	add_country("at","Austria");
	add_country("pl","Poland");
	add_country("cz","Czech Republic");
	add_country("hu","Hungary");
	add_country("sk","Slovakia");
	add_country("ru","Russia");

	add_country("jo","Jordan");
	add_country("qa","Qatar");
	add_country("ae","United Arab Emirates");
	add_country("za","South Africa");
	add_country("eg","Egypt");
	add_country("ma","Morocco");
	add_country("tn","Tunisia");
	add_country("na","Namibia");
	add_country("bw","Botswana");
	add_country("ng","Nigeria");

	add_country("sg","Singapore");
	add_country("my","Malaysia");
	add_country("ph","Philippines");
	add_country("vn","Vietnam");
	add_country("bd","Bangladesh");
	add_country("pk","Pakistan");
	add_country("lk","Sri Lanka");
	add_country("kr","South Korea");
	add_country("mu","Mauritius");
	add_country("om","Oman");
	
	emit finito(res_);
}

void getquote::httpRequestFinished(int /* id */, bool err)
{
	if (err)
	{
		qWarning() << "Erreur, pays= " << res_ << " " << HttpSock_.errorString();
		if (!finished_)
		{
			emit finito("");
			finished_ = true;
		}
		return;
	}
	QString answer(Reply_to_check_ptz_.data().data());

	QRegExp rx;
	rx.setMinimal(true);
	rx.setPattern(reg_);
	int pos = rx.indexIn(answer);
	if (pos > -1) {
		res_ += rx.cap(1);
		res_.replace(QString(","), QString("."));
		res_.replace(QString("\n"), QString(""));
		res_.simplified();
		res_ += "\n";
		if (!finished_)
		{
			emit finito(res_);
			finished_ = true;
		}
	}
}

int main(int argc, char *argv[])
{
	QCoreApplication app(argc, argv);
	waiter w(&app);

	w.wait_for_one_more_request();
	getquote_bourso g(&w);

	w.wait_for_one_more_request();
	getquote_index_record gir(&w);

	w.wait_for_one_more_request();
	getquote danemark("dk", "www.omxnordicexchange.com", "/", "OMXN40.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote norvege("no", "money.cnn.com", "/data/world_markets/", "OSE Industry.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote suede("se", "money.cnn.com", "/data/world_markets/", "OMX.*>([^<>]*)%", &w);

#if 0

	w.wait_for_one_more_request();
	getquote tunisie("tn", "www.bvmt.com.tn", "/quotes/indices.jsp", "TUNINDEX.*>([^<>]*)%", &w);


	w.wait_for_one_more_request();
	getquote australie("au", "money.cnn.com", "/data/world_markets/", "ASX 100.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote inde("in", "www.nse-india.com", "/homepage.htm", "P CNX NIFTY.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote russie("ru", "www.rts.ru" , "/en/index/rtsi/", "of Last Close.*>([^<>]*)%", &w);


	MidEast Africa
	____________________ Dubai  	Istanbul Nat 100 Turkey
		Cap Mkts Authority Egypt 	Nigeria All Shares Nigeria
		Kuwait All Share Kuwait 	Lusaka all Shares Zambia
		JSE All Shr South Afri 	Mauritius Semdex Mauritius
		____________________ Saudi Arab 	Nairobi_20 Kenya


		  	
		Europe
		http://www.econstats.com/eqty/eq_d_eu_0.htm
		FTSE 100 United Kin 	Bel 20 Belgium 	ATG Comp Greece 	BVL Gen Lisbon Portugal 	RTS Index Russia 	SAX All-Shr Sweden
		FTSE 250 United Kin 	PX50 Prague Czech Repu 	MIBTEL Mil Italy 	BVL 30 Portugal 	Moscow Times Russia 	AFGX Sweden
		DAX 30 Germany 	Køben Fonds Denmark 	MIB 30 Mil Italy 	PSI 20 Portugal
		Vienna ATX Austria 	CAC 40 France 	OSE All Share Norway 	MICEX 10 Russia 	IBEX 35 1994 Spain 	

		Asia Pacific
		http://www.econstats.com/eqty/eq_d_ap_0.htm

		Latin America
		http://www.econstats.com/eqty/eq_d_la_0.htm
		MerVal Argentina  	IBC Venezuela
		Bovespa Brazil 	
		IPSA Chile 	
		IPC All Shr Mexico 	
		Lima Gen Peru 


	// Voir http://www.glob-infobourse.com/index/liens/graph_param.html
	
	w.wait_for_one_more_request();
	getquote southafrica("za", "www.jse.co.za", "/", "All-Share.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote mongolie("mn", "www.???", "/", "All-Share.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote kazakhstan("kz", "www.???", "/", "All-Share.*>([^<>]*)%", &w);

#endif

#if 0
	w.wait_for_one_more_request();
	getquote turquie("tu", "www.indexrecord.com", "/stock/XU100.html", "Change %.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote bresil("br", "www.indexrecord.com", "/", "Brazil.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote venezuela("ve", "www.indexrecord.com", "/", "Venezuela.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote perou("pe", "www.indexrecord.com", "/", "Peru.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote chili("cl", "www.indexrecord.com", "/", "Chile.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote Argentina("ar", "www.indexrecord.com", "/", "Argentina.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote Mexico("mx", "www.indexrecord.com", "/", "Mexico.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote Colombia("co", "www.indexrecord.com", "/", "Colombia.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote israel("il", "www.indexrecord.com", "/", "Israel.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote arabie_sahoudite("sa", "www.indexrecord.com", "/", "Saudi Arabia.*>([^<>]*)%", &w);

	w.wait_for_one_more_request();
	getquote Mongolia("mn", "www.indexrecord.com", "/", "Mongolia.*>([^<>]*)%", &w);

#endif

	w.wait_for_end();
	app.exec();
	return 0;
}

